/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.nplusc.izc.Utilities.WPCMgr.Editor;

import de.nplusc.izc.tools.IOtools.FileTK;
import de.nplusc.izc.tools.IOtools.SimplifiedFile;
import de.nplusc.izc.tools.UiToolz.UiTools;
import de.nplusc.izc.tools.baseTools.Lock;
import de.nplusc.izc.tools.baseTools.Tools;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import org.yaml.snakeyaml.Yaml;

/**
 *
 * @author LH
 */
public class ManagerGUI extends javax.swing.JFrame
{
    private int ph,pw;
    private Graphics2D imagepreviewPanel;
    private Yaml yp = new Yaml();
    //public static Lock LoadLock = new Lock();
    private String pack;
    private WallpaperPackage wp;
    private boolean packageLoadedAlready = false;
    private DefaultListModel lm;
    private String selfile = "";
    /**
     * Creates new form ManagerGUI
     */
    public ManagerGUI()
    {
        initComponents();
        imagepreviewPanel = (Graphics2D) pnlPreview.getGraphics();
        String[] packageDirs = FileTK.getDirectoryContent(Settings.cacheBaseDir);
        for (int i = 0; i < packageDirs.length; i++)
        {
            String dir = packageDirs[i];
            dir=FileTK.getFileName(dir);
            if(dir.startsWith("00_")||!FileTK.isDir(dir))
            {
                dir=null;
            }
            packageDirs[i]=dir;
        }
        ((DefaultComboBoxModel)cbxPackages.getModel()).removeElementAt(0);
        for (String string : packageDirs)
        {
            if(string!=null)
                cbxPackages.addItem(string);
        }
        lm=(DefaultListModel) lstFilezzz.getModel();
        ph=pnlPreview.getHeight();
        pw=pnlPreview.getWidth();
        imagepreviewPanel.setColor(Color.black);
    }

    
    //[392, 244]
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        cbxPackages = new javax.swing.JComboBox();
        loadPackage = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstFilezzz = new javax.swing.JList();
        pnlPreview = new javax.swing.JPanel();
        cxkeepaspect = new javax.swing.JCheckBox();
        cxBframe = new javax.swing.JCheckBox();
        processAndInstall = new javax.swing.JButton();
        btnReDraw = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        pProgress = new javax.swing.JProgressBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        cbxPackages.setModel(new javax.swing.DefaultComboBoxModel(new String[] {"Error@Init" }));

        loadPackage.setText("Package laden");
        loadPackage.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                loadPackageActionPerformed(evt);
            }
        });

        lstFilezzz.setModel(new javax.swing.DefaultListModel());
        lstFilezzz.addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                lstFilezzzMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(lstFilezzz);

        pnlPreview.setFocusable(false);

        javax.swing.GroupLayout pnlPreviewLayout = new javax.swing.GroupLayout(pnlPreview);
        pnlPreview.setLayout(pnlPreviewLayout);
        pnlPreviewLayout.setHorizontalGroup(
            pnlPreviewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        pnlPreviewLayout.setVerticalGroup(
            pnlPreviewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        cxkeepaspect.setText("keepAspectRatio");
        cxkeepaspect.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cxkeepaspectActionPerformed(evt);
            }
        });

        cxBframe.setText("B-Frame");
        cxBframe.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cxBframeActionPerformed(evt);
            }
        });

        processAndInstall.setText("Processs");
        processAndInstall.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                processAndInstallActionPerformed(evt);
            }
        });

        btnReDraw.setText("ReDraw");
        btnReDraw.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnReDrawActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(cbxPackages, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(loadPackage))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 349, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pnlPreview, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(btnReDraw)
                        .addGap(35, 35, 35)
                        .addComponent(processAndInstall))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cxkeepaspect)
                            .addComponent(cxBframe))
                        .addGap(0, 285, Short.MAX_VALUE))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cbxPackages, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(loadPackage))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlPreview, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cxkeepaspect)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(processAndInstall)
                            .addComponent(btnReDraw)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cxBframe)
                        .addContainerGap())))
        );

        jTabbedPane1.addTab("ProcessPackages", jPanel2);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 747, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 311, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("#NN#", jPanel3);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
            .addComponent(pProgress, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 339, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(pProgress, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnReDrawActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnReDrawActionPerformed
    {//GEN-HEADEREND:event_btnReDrawActionPerformed
        //TESTER\/
        imagepreviewPanel.setColor(Color.black);
        imagepreviewPanel.drawRect(0, 0, /*3*/92, /*2*/44);
        imagepreviewPanel.fillRect(0, 0, /*3*/92, /*2*/44);
        try
        {
            BufferedImage bi = ImageIO.read(new File("T:\\icns\\mcicon.png"));
            imagepreviewPanel.drawImage(bi, 0, 0, null);
            //pnlPreview.repaint();
            //repaint();

            System.err.println("....");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_btnReDrawActionPerformed

    private void processAndInstallActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_processAndInstallActionPerformed
    {//GEN-HEADEREND:event_processAndInstallActionPerformed

        //createBlackBackground nur einmal. bei settingschange wid das file gelöscht zur neuinitialisierung
        if(!new File(Settings.canvasDir).exists())
        {
            String initCanvas = "convert -size "+Settings.ScreenWidth+"x"+Settings.ScreenHeight+"xc:#000000 "+Settings.canvasDir;
            Tools.runSingleCmd(false,true,initCanvas);
        }
        String[][] filelist = wp.FileList;
        imagcmds = new String[filelist.length];
        String tpath="";
        //process_b_frames_after_that
        //keepaspect=1;b-frame=2;
        int i=0;
        for (String[] filesetr : filelist)
        {

            if(filesetr[1]==null)
            filesetr[1]="false";
            String spath = Settings.cacheBaseDir+pack+"\\"+filesetr[0];
            String cvt = tpath = Settings.cacheBaseDir+pack+"\\"+"p"+"\\"+filesetr[0];
            if(filesetr[1].equals("true"))
            {
                tpath = Settings.cacheBaseDir+pack+"\\"+"k_i_p"+"\\"+filesetr[0];
                String cmdpart1 = "convert -geometry '"+Settings.ScreenWidth+"x"+Settings.ScreenHeight+"' -";/// <<<proportional danach mit && ein merge auf ne schwarze datei mit screensize
                String cmdpart2 = "composite -gravity center - "+Settings.canvasDir+" "+tpath+" "+cvt;
                imagcmds[i] = cmdpart1+"|"+cmdpart2;
            }
            else
            {
                tpath = Settings.cacheBaseDir+pack+"\\"+"proc"+"\\"+filesetr[0];
                //convert -geometry wodthxheight!
                imagcmds[i] = "convert -geometry '"+Settings.ScreenWidth+"x"+Settings.ScreenHeight+"!' "+tpath+" "+cvt;

            }
            //FileTK.kopierpaste(new File(spath),new File(tpath));
            i++;
        }
        pProgress.setMinimum(0);
        pProgress.setMaximum(imagcmds.length);

        new Thread(new Runnable()
            {
                @Override
                public void run()
                {
                    int i=0;
                    for (String cmd : imagcmds)
                    {
                        System.err.println(cmd);
                        //Tools.runSingleCmd(false, true, cmd);
                        pProgress.setValue(i);
                        i++;
                    }
                }
            }).start();
    }//GEN-LAST:event_processAndInstallActionPerformed

    private void cxBframeActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cxBframeActionPerformed
    {//GEN-HEADEREND:event_cxBframeActionPerformed
        String[][] contentlist = wp.FileList;
        int ipos = 0;
        for (int i = 0; i < contentlist.length; i++)
        {
            if(contentlist[i][0].equals(selfile))
            {
                ipos=i;
                break;
            }
        }
        if(cxBframe.isSelected())
        {

            contentlist[ipos][2]="true";
        }
        else
        {
            contentlist[ipos][2]="false";
        }
    }//GEN-LAST:event_cxBframeActionPerformed

    private void cxkeepaspectActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cxkeepaspectActionPerformed
    {//GEN-HEADEREND:event_cxkeepaspectActionPerformed
        String[][] contentlist = wp.FileList;
        int ipos = 0;
        for (int i = 0; i < contentlist.length; i++)
        {
            if(contentlist[i][0].equals(selfile))
            {
                ipos=i;
                break;
            }
        }
        if(cxkeepaspect.isSelected())
        {

            contentlist[ipos][1]="true";
        }
        else
        {
            contentlist[ipos][1]="false";
        }
    }//GEN-LAST:event_cxkeepaspectActionPerformed

    private void lstFilezzzMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_lstFilezzzMouseClicked
    {//GEN-HEADEREND:event_lstFilezzzMouseClicked
        try
        {
            //if(switched);
            String filename = (String) lm.get(lstFilezzz.getSelectedIndex());
            selfile=filename;
            String path = Settings.cacheBaseDir+pack+"\\"+filename;
            switched=true;
            UiTools.ScaleImageIntoFrame(path, imagepreviewPanel,ph,pw);
            //System.err.println(".........."+t);
            String[][] contentlist = wp.FileList;
            int ipos = 0;
            for (int i = 0; i < contentlist.length; i++)
            {
                if(contentlist[i][0].equals(selfile))
                {
                    ipos=i;
                    break;
                }
            }
            String bfrv=contentlist[ipos][2],keepaspv=contentlist[ipos][1];
            if(bfrv==null)
            bfrv="false";
            if(keepaspv==null)
            keepaspv="false";
            if(keepaspv.equals("true"))
            {
                cxkeepaspect.setSelected(true);
            }
            else
            {
                cxkeepaspect.setSelected(false);
            }
            if(bfrv.equals("true"))
            {
                cxBframe.setSelected(true);
            }
            else
            {
                cxBframe.setSelected(false);
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_lstFilezzzMouseClicked

    private void loadPackageActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_loadPackageActionPerformed
    {//GEN-HEADEREND:event_loadPackageActionPerformed

        if(packageLoadedAlready)
        {
            String path = Settings.cacheBaseDir+pack;
            String sy = yp.dump(wp);
            FileTK.writeFile(sy, path+"\\meta.yml");
        }
        pack = (String)cbxPackages.getSelectedItem();
        String path = Settings.cacheBaseDir+pack;
        //            name,keepAspect,isBFrame,numericID;
        //\/  [itemcount][4]
        String[]         [] content=null;
        if(new File(path+"\\meta.yml").exists())
        {
            String cnt ="";
            String[] filecnt = FileTK.fileload(path+"\\meta.yml");
            for (String string : filecnt)
            {
                cnt+="\n"+string;

            }

            cnt=cnt.substring(1,cnt.length()-5);
            System.err.println(cnt);
            wp = (WallpaperPackage)yp.load(cnt);
            content = wp.FileList;
            for (String[] etr : content)
            {
                lm.addElement(etr[0]);
            }
        }
        else
        {
            wp=new WallpaperPackage();
            String[] fileList = FileTK.getDirectoryContent(path);
            for (int i = 0; i < fileList.length; i++)
            {
                String etr = fileList[i];
                if(new File(etr).isDirectory())
                {
                    fileList[i]=null;
                    continue;
                }
                if(FileTK.getFileExt(etr).equals("yml"))
                {
                    fileList[i]=null;
                    continue;
                }
                etr=FileTK.getFileName(etr);
                fileList[i]=etr;
            }
            lm.clear();
            int clength = 0;
            for (String etr : fileList)
            {
                if(etr!=null)
                {
                    lm.addElement(etr);
                    clength++;
                }
            }
            //name,keepAspect,isBFrame,numericID;
            content = new String[clength][4];
            int i = 0;
            for (String etr : fileList)
            {
                if(etr!=null)
                {
                    content[i][0] = etr;
                    i++;
                }
            }
            wp.FileList=content;
            packageLoadedAlready=true;
        }

    }//GEN-LAST:event_loadPackageActionPerformed

    
    @SuppressWarnings("empty-statement")//used here to make the hack workin like intended
    boolean switched = false;
    
    
    //proportional_path=k_i_p
    //b-frames_path=b-frames
    //temptarget=p
    //scale-without-aspect=proc
    String[] imagcmds;
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try
        {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels())
            {
                if ("Nimbus".equals(info.getName()))
                {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        }
        catch (ClassNotFoundException ex)
        {
            java.util.logging.Logger.getLogger(ManagerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        catch (InstantiationException ex)
        {
            java.util.logging.Logger.getLogger(ManagerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        catch (IllegalAccessException ex)
        {
            java.util.logging.Logger.getLogger(ManagerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        catch (javax.swing.UnsupportedLookAndFeelException ex)
        {
            java.util.logging.Logger.getLogger(ManagerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                //new IconMgrDBV().setVisible(true);
                new ManagerGUI().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnReDraw;
    private javax.swing.JComboBox cbxPackages;
    private javax.swing.JCheckBox cxBframe;
    private javax.swing.JCheckBox cxkeepaspect;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton loadPackage;
    private javax.swing.JList lstFilezzz;
    private javax.swing.JProgressBar pProgress;
    private javax.swing.JPanel pnlPreview;
    private javax.swing.JButton processAndInstall;
    // End of variables declaration//GEN-END:variables
}
