/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package de.nplusc.izc.logblockheatmapper;

import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import javax.imageio.ImageIO;

/**
 *
 * @author iZc <nplusc.de>
 */
public class LogBlockHeatmapper
{
      //x  y
    static int[ ][ ] dataField ;
    static int max=0;
    static int size;
    static int targetBlockID=-1;
    static boolean removalsOnly=false;
    static BufferedImage gradient = new BufferedImage(1024,1,BufferedImage.TYPE_4BYTE_ABGR);
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)throws Exception
    {       
        if(args.length<2)
        {
            throw new UnsupportedOperationException("not enough parameters");
        }
        if(args.length>2)
        {
            targetBlockID = Integer.valueOf(args[2]);
            if(args.length>3)
            {
                removalsOnly = Boolean.valueOf(args[3]);
            }
        }
        int size = Integer.valueOf(args[1]);
        dataField = new int[size][size];
        GradientPaint p = new GradientPaint(0, 0, Color.blue, 1023, 0, Color.red);
        Graphics2D lw = (Graphics2D) gradient.getGraphics();
        lw.setPaint(p);
        lw.fillRect(0, 0, 1023, 1);
        BufferedReader br = new BufferedReader(new FileReader(args[0]));
        br.lines().forEach((xx)->
        {
            
            //4 als 5 und nen bisschen arithmetik gibt seitwärts-schnittansicht
            //id_0  oldblox_1 newblox_2 newdv_3  X_4    height_5 y_6 
            //10	5	0	0	-1373	27	4008
            String[] xes = xx.split("\\t");
            int l = Integer.parseInt(xes[0]);
            boolean register=false;
            int f = Integer.parseInt(xes[1]);
            int t = Integer.parseInt(xes[2]);
            if((targetBlockID<0||targetBlockID==f||targetBlockID==t))
            {
                register=true;
            }
            if(removalsOnly&&t==targetBlockID)
            {
                register=false;
            }
            int x= Integer.parseInt(xes[4])+size/2,y= Integer.parseInt(xes[6])+size/2;
            //-y=up
            if(x<size&&x>=0&&y<size&&y>=0&&register)
            {
                //minecraftlogik.....
                dataField[x][y]+=1;
                if(dataField[x][y]>max)
                {
                    max=dataField[x][y];
                }
            }
            if(l%10000==0)
            {
                System.out.print(l+"changes so far\r");
            }
            
            
        });  
        System.out.print("Database crunched to 100%\n maximum changes on coordinates were:" +max +"\n");
        //max=Math.min(max, 1000);
        //int steps=max/256;
        //BufferedWriter bw = new BufferedWriter(new FileWriter(new File("D:/emc2/arca_slash/database/crunched.pgm")));
        //bw.write("P6");
        //bw.newLine();
        //bw.write("20000 20000");
        //bw.newLine();
        //bw.write("255");
        //bw.newLine();
        BufferedImage bi = new BufferedImage(size,size, BufferedImage.TYPE_4BYTE_ABGR);
        //SELECT id, replaced, `type`, `data`, x, y, z 
        //FROM `lb-surv`
        //INTO OUTFILE 'D:/emc2/arca_slash/database/lbcrunchsurvival.csv';

        //0-49 1 stufe=1 farbschritt 50 -1049: 10 stufen pro farbschritt: rest gleichmäßig aufgeteilt bis maximum
        for (int i = 0; i < dataField.length; i++)
        {
            int[] is = dataField[i];
            for (int j = 0; j < is.length; j++)
            {
                int color=Color.white.getRGB();
                int k = is[j];
                if(k==0)
                {   
                    color=Color.white.getRGB();
                    //bw.write("255 255 255");
                    //bw.write(255);bw.write(255);bw.write(255);
                }
                else
                {
                    if(max>1050)
                    {
                        //k/=steps;
                        if(k<50)
                        {
                            color= gradient.getRGB(k*16, 0);

                        }
                        else
                        {
                            if(k<1050)
                            {
                                k-=50;
                                color= gradient.getRGB(800+k/10, 0);  
                            }
                            else
                            {
                                k-=1050;
                                int stepWidth = (max-1050)/(123);
                                if(stepWidth==0)
                                    stepWidth++;
                                color= gradient.getRGB(Math.min(1023,900+k/stepWidth), 0);
                            }
                            int r=(color&0xFF0000)>>16;
                            int g=(color&0xff00)>>8;
                            int b=color&0xff;
                            //bw.write(r);bw.write(g);bw.write(b);
    //writeBy(r+" "+g+" "+b);
                        }
                    }
                    else
                    {
                        if(k<25)
                        {
                            color= gradient.getRGB(k*32, 0);

                        }
                        else
                        {
                            int stepWidth = (max-50)/(223);
                            if(stepWidth==0)
                                    stepWidth++;
                            color= gradient.getRGB(Math.min(1023,800+k/stepWidth+1), 0);
                        }
                    }
                }
                bi.setRGB(i, j, color);
                //bi.setRGB(i,j,k<<16&k<<8&k);
                //if(j<19999)
               // {
                    //bw.write(" ");
               // }
            }
            //if(i<19999)
               // bw.newLine();
            System.out.print(i+"lines rasterized\r");
        }
        //bw.close();
        ImageIO.write(bi, "png",new File( "D:/emc2/arca_slash/database/heatmap.png"));
    }
    
}
